getbeer
=======

Send SMS message from the shell using curl and Vox.io. Also
includes a OSX widget that will execute when a selected
process ends.

Wrote this while waiting for crosstool to finish compiling and
not wanting to sit around waiting for it when I could be enjoying
a drink at the corner bar instead. Hence cut+paste the command
into a shell that is busy compiling, go get a beer, and an SMS
when the compile has finished.

Requires a [Vox.io](http://vox.io) acount and local curl installed.
Execute and see usage for instructions.

NOTE: vox.io does not support SSL 

getbeer.sh Usage
----------------

```
getbeer.sh [[-p <password>] -u <usename>] [-n <phone#> -m "<message>"] [-d]

  -p --pass  <password>  (optional)
  -u --user  <username>
      When both provided authenticates and logs in to vox.io.
      When just -u provided, authenticates but prompts user
      for password. If both ommited, assumes login session
      was already built (session cookie stored on disk).

  -n --phone <phone#>
  -m --msg   "<message>"
      When both provided sends message to vox.io and then logs
      the user out and deletes session cookie from disk.

  -d --dryrun
      This option prints the commands executed but does not
      attempt to authenticate or send messages. Useful when 
      wanting to send messages on a machine with curl but
      without this script.

  Examples:
    getbeer.sh -p mypassword -u myusername
    # logs user in and stores session
    getbeer.sh -n +12035555555 -m "my message"
    # uses previously stored login credentials and sends msg
    getbeer.sh -u myusername -n +12035555555 -m "my message"
    # Logs in and sends msg. prompts user for password
    getbeer.sh -u myusername -n +12035555555 -m "my message" -d
    # Adding the -d flag causes the program to print the
    # commands without executing. These can then be pasted
    # into a shell where a process is currently running and
    # when the process is finished they will execute.

```

OSX Widget Usage
----------------

See [OSX Widget README](tree/master/osx_widget/) readme for detailed instructions.

![Selecting process to watch screenshot](http://github.com/cyphunk/getbeer/raw/master/osx_widget/screenshot_2_selectProc.png)

