/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */


function parsePs(output) {
    var pslist = document.getElementById("ps");
    var psout = output.outputString.split("\n");
    var pslistOptions = [["SendSMS now","0"],["<PID> <COMMAND>","0"]];
    for ($i = 0; $i < psout.length-1; $i++) {
        var pid = psout[$i].split(/\s+/g)[0];
        var cmd = psout[$i].split(/\s+/g).slice(4)[0];
        pslistOptions.push([psout[$i],pid]);
    }
    pslist.object.setOptions(pslistOptions);

}
function loadPs() {
    //var pscmd = "/bin/ps -u user | awk '{$1=\"\";$3=\"\";$4=\"\"; print}' | tail -n +2 | egrep -v 'ps -u|awk {\$1|tail -n +2|egrep -v'";
    var pscmd = "/bin/ps | awk '{$2=\"\";$3=\"\"; print}' | tail -n +2 | egrep -v 'ps -u|awk {\$1|tail -n +2|egrep -v'";
    var psout = widget.system(pscmd, parsePs)
}
//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    var username = widget.preferenceForKey("username");
    var phone = widget.preferenceForKey("phone");
    if (username) 
        document.getElementById("username").value = username        
    if (phone)
        document.getElementById("phone").value = phone;
    
    loadPs();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    loadPs();
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
            
}  

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function sendSms(event)
{
    var referrerUrl = "http://vox.io/";
    var loginUrl = "http://vox.io/auth.localauthentication/authenticate";
    var sendSmsUrl = "http://vox.io/messaging/sendsms";
    
    // If global/preferences (username, phone) changed since init, save them:
    var username = document.getElementById("username").value
    var phone = document.getElementById("phone").value
    widget.setPreferenceForKey(username, "username");
    widget.setPreferenceForKey(phone, "phone");
    // Get locals:
    var password = document.getElementById("password").value;
    var message = document.getElementById("message").value;
    
    var debug = document.getElementById("debug");
    debug.value = "";
    var indicator = document.getElementById("indicator");
    var off=0, green=1, yellow=10, red=15;


    //
    // LOGIN
    //
    var xhr = new XMLHttpRequest();
    xhr.open("GET", loginUrl+"?username="+encodeURIComponent(username)+"&password="+encodeURIComponent(password), false);
    xhr.withCredentials = "true";  
    xhr.setRequestHeader("Referrer",referrerUrl);
    xhr.send(null);
    // check response
    if (xhr.status == 200) {
        indicator.object.setValue(yellow);
        var retdata = JSON.parse(xhr.responseText);
        if (retdata.status == true) {
            indicator.object.setValue(green);
        }
        else {
            debug.value = xhr.responseText+"\n";
            //return 1;
        }
    }
    else {
        indicator.object.setValue(red);
        debug.value += xhr.status+"\n"; 
        //return 1;
    }  
     
    // SEND MESSAGE
    xhr.open("GET", sendSmsUrl+"?to="+encodeURIComponent(phone)+"&message="+encodeURIComponent(message), false);
    xhr.withCredentials = "true";  
    xhr.setRequestHeader("Referrer",referrerUrl);
    xhr.send(null);
    if (xhr.status == 200 && xhr.responseText == "ok") {
        indicator.object.setValue(green);
    }
    else {
        indicator.object.setValue(red);
        debug.value += xhr.responseText +"\n"+xhr.status;
    }

    /* // POST METHOD, DOESNT WORK
    var xhr = new XMLHttpRequest();
    xhr.onload = onloadHandler;
    xhr.open("POST", sendSmsUrl, false);
    xhr.setRequestHeader("Content-type","application/x-www-form-urlencoded");
    xhr.setRequestHeader("Referrer",referrerUrl);
    xhr.send("to="+phone+"&message="+message);
    */
}

function sendOnPidEnd() {
    var pslistPid = document.getElementById("ps").object.getValue();
    if (pslistPid >= 1) {
        var psout = widget.system("/bin/ps -p "+pslistPid+" | tail -n +2", null).outputString;
        if (psout) {
            setTimeout(sendOnPidEnd, 4000);
        }
        else {
            sendSms(null);
        }
    }
}
function setSendOnPidEnd(event)
{
    var pslist = document.getElementById("ps");
    var pslistIndex = pslist.object.getSelectedIndex();
    pslistPid = pslist.object.getValue();
    var sendBtn = document.getElementById("send");
    var debug = document.getElementById("debug");
    if (pslistPid >= 1) {
        debug.value = "Sending SMS on close of process PID: "+pslistPid;
        sendOnPidEnd();
        sendBtn.object.setEnabled(false);
        sendBtn.style.opacity = 0.5;
    }
    else {
        debug.value = "";
        sendBtn.object.setEnabled(true);
        sendBtn.style.opacity = 1.0;
        pslist.object.setSelectedIndex(0);
    }
}


function refreshPsList(event)
{
    loadPs();
    var sendBtn = document.getElementById("send");
    var debug = document.getElementById("debug");
    debug.value = "";
    sendBtn.object.setEnabled(true);
    sendBtn.style.opacity = 1.0;
}
